property pDelim, pSourceRootFolder, pDestRootFolder, pButtonMode, pImageCode

on beginSprite me
  pDelim = getPathDelim()
  pDestRootFolder = baSysFolder("desktop") & member("CD_title_enter").text & pDelim
  rootPath = getRootPath()
  pSourceRootFolder = rootPath
end

on mouseUp me
  Section = utilsGetSection()
  stateList = utilsGetState(Section)
  pImageCode = stateList.imageCode
  cdNameFolder = "low_res" & pDelim
  imageCodeFileName = stateList.imageCode & ".jpg"
  if pButtonMode = #downloadImage then
    me.downloadImage(cdNameFolder, imageCodeFileName)
  else
    me.DeleteImage(cdNameFolder, imageCodeFileName)
  end if
end

on downloadImage me, cdNameFolder, imageCodeFileName
  cursor(4)
  sourceFilename = pSourceRootFolder & cdNameFolder & imageCodeFileName
  destFilename = pDestRootFolder & cdNameFolder & imageCodeFileName
  if not globalFolderExist(pDestRootFolder) then
    CreateDirectory(pDestRootFolder)
  end if
  if not globalFolderExist(pDestRootFolder & cdNameFolder) then
    CreateDirectory(pDestRootFolder & cdNameFolder)
  end if
  CopyFile(sourceFilename, destFilename)
  cursor(-1)
end

on DeleteImage me, cdNameFolder, imageCodeFileName
  cursor(4)
  fileToDelete = pDestRootFolder & cdNameFolder & imageCodeFileName
  DeleteFile(fileToDelete)
  utilsDeleteImageCode(pImageCode)
  fileList = DirectoryToList(pDestRootFolder & cdNameFolder)
  if (fileList = VOID) or (fileList = []) then
    DeleteDirectory(pDestRootFolder & cdNameFolder)
  end if
  fileList = DirectoryToList(pDestRootFolder)
  if (fileList = VOID) or (fileList = []) then
    DeleteDirectory(pDestRootFolder)
  end if
  cursor(-1)
  localJumpToThumbnails()
end

on getPropertyDescriptionList
  p_list = [:]
  addProp(p_list, #pButtonMode, [#format: #symbol, #default: #downloadImage, #range: [#downloadImage, #DeleteImage], #comment: "Select button function: "])
  return p_list
end
