property pDelim, pSourceRootFolder, pDestRootFolder, pButtonMode, pImageCode, pResFolder

on beginSprite me
  pDelim = getPathDelim()
  baRegister("digitalvision", 3766816)
  pDestRootFolder = baSysFolder("desktop") & member("CD_title_enter").text & pDelim
  rootPath = getRootPath()
  pSourceRootFolder = rootPath
end

on mouseUp me
  Section = utilsGetSection()
  stateList = utilsGetState(Section)
  pImageCode = stateList.imageCode
  cdNameFolder = pResFolder & pDelim
  imageCodeFileName = stateList.imageCode & ".jpg"
  if pButtonMode = #downloadImage then
    me.downloadImage(cdNameFolder, imageCodeFileName)
  else
    me.DeleteImage(cdNameFolder, imageCodeFileName)
  end if
end

on downloadImage me, cdNameFolder, imageCodeFileName
  cursor(4)
  sourceFilename = pSourceRootFolder & cdNameFolder & imageCodeFileName
  destFilename = pDestRootFolder & cdNameFolder & imageCodeFileName
  if baFileExists(sourceFilename) then
    if not globalFolderExist(pDestRootFolder) then
      CreateDirectory(pDestRootFolder)
    end if
    if not globalFolderExist(pDestRootFolder & cdNameFolder) then
      CreateDirectory(pDestRootFolder & cdNameFolder)
    end if
    CopyFile(sourceFilename, destFilename)
    alert("you have downloaded the image" && imageCodeFileName & " in " && cdNameFolder && "format")
  else
    alert("Can't download.  The file " & sourceFilename & " does not exist")
  end if
  cursor(-1)
end

on DeleteImage me, cdNameFolder, imageCodeFileName
  cursor(4)
  fileToDelete = pDestRootFolder & cdNameFolder & imageCodeFileName
  DeleteFile(fileToDelete)
  utilsDeleteImageCode(pImageCode)
  fileList = DirectoryToList(pDestRootFolder & cdNameFolder)
  if (fileList = VOID) or (fileList = []) then
    DeleteDirectory(pDestRootFolder & cdNameFolder)
  end if
  fileList = DirectoryToList(pDestRootFolder)
  if (fileList = VOID) or (fileList = []) then
    DeleteDirectory(pDestRootFolder)
  end if
  cursor(-1)
  localJumpToThumbnails()
end

on getPropertyDescriptionList
  p_list = [:]
  addProp(p_list, #pButtonMode, [#format: #symbol, #default: #downloadImage, #range: [#downloadImage, #DeleteImage], #comment: "Select button function: "])
  addProp(p_list, #pResFolder, [#format: #string, #default: "lowres", #range: ["low_res", "med_res", "hi_res"], #comment: "Select resolution to download: "])
  return p_list
end
